/*  */

version = '1.22'

arg input

call prg_init

if stream(lng._file, 'c', 'query exists') = ''
  then signal error_254_1
if stream(lng._file, 'c', 'open read') <> 'READY:'
  then signal error_254_2

say ': Reading' lng._file

signal on error name error_250_1
signal on syntax name error_250_1

idx = 0
m   = 0            /* Einlesemodus */
lng = 0            /* Anzahl definierter Sprachen */
lng._index._idx = ''
lng._alias._idx = ''


size = stream(lng._file, 'c', 'query size')

do l = 1 while lines(lng._file) > 0
  data = linein(lng._file)

  if l // 40 = 0
    then call charout, 'R:' format(stream(lng._file, 'c', 'seek') * 100 % size, 3)'%'cr

  if data = ''
    then iterate l             /* Leerzeilen verwerfen */
  parse var data keyword kwdata';'
  if keyword = ''
    then iterate l             /* Kommentarzeilen verwerfen */
  keyword = translate(keyword)

  parse var keyword vart1'.'vart2'.'vart3

  select
    when keyword = 'ALIAS'
      then
      do
        if m = 1
          then signal error_253_1
        if words(kwdata) <> 2
          then signal error_253_2
        lidx = word(kwdata, 1)
        lalias = translate(word(kwdata, 2))
        if \datatype(lidx, 'w') | lidx < 0 |,
           verify(lalias, alphanum) > 0
          then signal error_253_2
        if wordpos(lidx, lng._index._idx) > 0 |,
           wordpos(lalias, lng._alias._idx) > 0
          then signal error_253_3
        lng = lng +1
        lng._index._idx = lng._index._idx lidx
        lng._alias._idx = lng._alias._idx lalias
        lng._index.lng  = lidx          /* Index fr Sprache */
        lng._alias.lng  = lalias        /* Alias */
        lng._str.lng    = str_idx       /* Kennungen fr MSG-Str */
      end


    otherwise

      if m = 0
        then
        do
          p = wordpos(def_lng, lng._alias._idx)
          if p = 0
            then signal error_253_7
          def_lng = lng._index.p
          m = 1
          lng._lstr = log_str_idx       /* Kennungen fr Logfile-Str */
          lng._estr = error_idx         /* Kennungen fr Error-Str */
        end
      string = translate(strip(kwdata), '  ', '~"')
      select
        when vart1 = 'L'      /* Logfile-Meldung */
          then
          do
            if vart2 = def_lng
              then
              do
                p = wordpos(vart3, lng._lstr)
                if p = 0
                  then signal error_253_5
                lng._lstr = delword(lng._lstr, p, 1)
                idx = idx +1
                string.idx = 'def._log_str.'vart3'="'string'";'
                interpret string.idx       /* Syntax-Prfung */
              end
          end

        when vart1 = 'E'      /* Fehler-Meldung */
          then
          do
            if vart2 = def_lng
              then
              do
                p = wordpos(vart3, lng._estr)
                if p = 0
                  then signal error_253_6
                error._str.vart3.0 = error._str.vart3.0 +1
                y = error._str.vart3.0
                string = 'error._str.'vart3'.'y'="'string'";'
                interpret string           /* Syntax-Prfung */
                error._str.vart3.y = string
              end
          end

        when vart1 = 'M'      /* MSGs-Meldungen */
          then
          do
            if wordpos(vart2, lng._index._idx) = 0
              then signal error_253_4
            p = wordpos(vart3, lng._str.vart2)
            if p = 0
              then signal error_253_5
            lng._str.vart2 = delword(lng._str.vart2, p, 1)
            idx = idx +1
            string.idx = 'def._str.'vart2'.'vart3'="'string'";'
            interpret string.idx       /* Syntax-Prfung */
          end

        otherwise
          signal error_253_6

      end
  end
end
call stream lng._file, 'c', 'close'
signal off error
signal off syntax


res = 0
if lng._lstr <> ''
  then
  do
    res = 1
    say '* Missing logfile strings'
    do y = 1 to words(lng._lstr)
      say '* L.'def_lng'.'word(lng._lstr, y)
    end
  end
do l = 1 to lng
  if lng._str.l <> ''
    then
    do
      res = 1
      say '* Missing strings for msgs, language "'lng._alias.l'"'
      do y = 1 to words(lng._str.l)
        say '*' l'.'word(lng._str.l, y)
      end
    end
end

do y = 1 to words(error_idx)
  z = word(error_idx, y)
  select
    when error._str.z.0 > 0
      then nop
    when res = 2
      then say '* E.'def_lng'.'z
    otherwise
      res = 2
      say '* Missing strings for errors'
      say '* E.'def_lng'.'z
    end
end


if res = 0
  then
  do
    say ': Writing' int._file
    call sysfiledelete int._file

    def._language._idx = ' '
    do y = 1 to lng
      def._language._idx = def._language._idx || lng._alias.y' *'lng._index.y' '
      call charout int._file, 'def._language.'y'="'lng._alias.y'";'
    end
    call charout int._file, 'def._language='def_lng';'
    call charout int._file, 'def._language._idx="'def._language._idx'";'

    do y = 1 to idx
      call charout int._file, string.y
    end
    do y = 1 to words(error_idx)
      z = word(error_idx, y)
      call charout int._file, 'error._str.'z'.0='error._str.z.0';'
      do v = 1 to error._str.z.0
        call charout int._file, error._str.z.v
      end
      idx = idx + error._str.z.0
    end


    call stream int._file, 'c', 'close'
    say ':' idx 'strings processed'
  end

exit 0

/************************************************************************/

prg_init:

say
say left(' -= RAFX_LNG.CMD v'version' =-', 57) '(c) 1996-98 R.Wilke'
say copies('-', 78)

actdir = directory()
parse upper source . . p
parse value reverse(p) with '\' p
prgdir = reverse(p)

if words(input) = 0         /* Hilfe aufrufen */
  then signal prg_help

  /* REXXUTIL laden */
if rxfuncquery('sysloadfuncs') <> 0
  then
  do
    call rxfuncadd 'sysloadfuncs', 'rexxutil', 'sysloadfuncs'
    call sysloadfuncs
  end

def_lng = strip(input)
cr = '0d'x
alphanum = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789-_'
lng._file = prgdir'\RAFX_LNG.SRC'
int._file = prgdir'\RAFX.LNG'

/* L.n.m */
log_str_idx = '       1    2    3    4    5    6    7    8    9',
              ' 10                                             ',
              '      21   22             25   26   27          ',
              ' 30   31   32   33                              ',
              ' 40                       45   46               ',
              '100  101       103  104  105  106  107  108  109',
              '110  111  112  113  114  115       117       119',
              '120  121  122  123  124  125  126  127  128  129',
              '130  131  132  133  134  135  136            139',
              '140  141  142       144  145  146  147  148  149',
              '150       152  153  154                         ',
              '          162  163  164  165  166       168     ',
              '170       172  173  174  175  176  177  178  179',
              '180  181                                        '

/* M.n.m */
str_idx =     '  0    1    2    3    4    5    6    7    8    9',
              ' 10                  14   15   16               ',
              ' 20   21   22             25   26   27          ',
              ' 30   31   32   33                              ',
              ' 40                       45   46               ',
              '100  101  102  103       105  106       108  109',
              '110  111  112  113  114  115  116  117  118  119',
              '120  121  122  123  124  125  126  127  128  129',
              '130  131  132  133  134  135  136  137  138  139',
              '140  141  142  143  144  145  146  147  148  149',
              '150  151  152  153  154  155  156  157  158  159',
              '160  161  162  163  164  165  166  167          ',
              '170  171  172  173  174  175            178  179',
              '180  181  182  183  184  185  186  187  188  189',
              '190  191  192  193  194  195  196  197  198  199',
              '200  201  202  203  204                         ',
              '210  211  212  213                              '


/* E.n.m */
error_idx =   '  0    1    2    3    4    5    6    7    8    9',
              ' 10   11        13   14   15   16   17   18   19',
              ' 20   21   22   23   24   25   26   27        29',
              ' 30   31   32   33   34   35   36   37   38   39',
              ' 40        42   43   44   45   46   47   48     ',
              ' 50   51   52   53   54   55   56   57   58   59',
              ' 60   61        63   64   65   66   67   68     ',
              ' 70   71   72   73   74   75   76   77   78   79'

error. = 0   /* Strings Fehlermeldungen */



return

/************************************************************************/

prg_help:

say
say ' Converts RAFX_LNG.SRC to RAFX.LNG'
say
say ' Usage: RAFX_LNG.CMD [<language>]'
say
say ' <language> is the alias of the language for output to screen and logfile'
say

exit 0

/************************************************************************/

error_254_1:
say '*' lng._file 'not found'
exit 254

erorr_254_2:
say '* Error opening' lng._file'!'
exit 254

error_253_1:
call stream lng._file, 'c', 'close'
say '* Unknown keyword! Language aliases must '
say '* be definied before the strings.'
exit 253

error_253_2:
call stream lng._file, 'c', 'close'
say '* Error in line' l
say '* Index must be a whole number greater 0.'
say '* Language alias must be a unique word. Only'
say '* the characters A-Z, 0-9, _ and - area allowed.'
exit 253

error_253_3:
call stream lng._file, 'c', 'close'
say '* Error in line' l
say '* Index or alias must be unique'
exit 253

error_253_4:
call stream lng._file, 'c', 'close'
say '* Error in line' l
say '* There is no alias definied for this index.'
exit 253

error_253_5:
call stream lng._file, 'c', 'close'
say '* Error in line' l
say '* Unknown string or string is already definied'
exit 253

error_253_6:
call stream lng._file, 'c', 'close'
say '* Error in line' l
say '* Unknown identifier'
exit 253

error_253_7:
call stream lng._file, 'c', 'close'
say "* Unknown language '"def_lng"'"
exit 253


error_250_1:
call stream lng._file, 'c', 'close'
say '* Error converting line' l
say '* Error' rc',' errortext(rc)
exit 250
