/* TOKENIZE.CMD */

arg input .

version = '1.02'
say
say left(' -= TOKENIZE.CMD v'version' =-', 60) '(c) R.Wilke 1997'
say copies('-', 78)

if rxfuncquery('sysloadfuncs') <> 0
  then
  do
    call rxfuncadd 'sysloadfuncs', 'rexxutil', 'sysloadfuncs'
    call sysloadfuncs
  end
if rxfuncquery('rxuinit') <> 0
  then
  do
    call rxfuncadd 'rxuinit', 'rxu', 'rxuinit'
    call rxuinit
  end

if input = ''
  then signal tokenize_help
prg = stream(input, 'c', 'query exists')
if prg = ''
  then signal error_255_2
parse upper var prg root'.CMD'rest
if rest <> ''
  then signal error_255_3
tkn = root'.TKN'
if stream(prg, 'c', 'open read') <> 'READY:'
  then signal error_255_1
size = chars(prg)
say ': Bearbeite' prg '('size 'Bytes)'
call stream prg, 'c', 'close'
prg_str = charin(prg,, chars(prg))

signal on error name error_255_4
signal on syntax name error_255_4
tkn_str = rxtokenize(prg_str)
call sysfiledelete tkn
say ': Erstelle' tkn '('length(tkn_str) 'Bytes)'
call charout tkn, tkn_str
call stream tkn, 'c', 'close'
say
exit 0

/************************************************************************/

tokenize_help:

say
say ' Erstellt aus einem REXX-Script ein File, da nur die Tokens enthlt'
say ' Das Token-File wird im selben Verzeichnis, wie das CMD-File erstellt'
say ' und hat die Endung .TKN. Ein schon vorhandenes Token-File wird ohne'
say ' Warnung berschrieben.'
say
say ' Anwendung: TOKENIZE.CMD [<file>]'
say
say ' Optionen:  <file>    Das zu bearbeitende REXX-Script'
say '            keine zeigt diese Hilfe hier'
say

exit 0

/************************************************************************/

error_255_1:
say '* Fehler beim ffnen von' prg '!'
exit 255

error_255_2:
say '*' input 'nicht gefunden!'
exit 255

error_255_3:
say '*' prg 'ist kein CMD-File!'
exit 255

error_255_4:
say '* Fehler bei Umsetzung'
exit 255

